diff -urN qmail-1.03-vanilla/qmail-smtpd.c qmail-1.03-md24/qmail-smtpd.c
--- qmail-1.03-vanilla/qmail-smtpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-smtpd.c	2007-08-13 21:27:36.000000000 +0200
@@ -1,3 +1,18 @@
+
+#define DEFAULT_TIMEOUT   100
+#define DEFAULT_MAXHOPS   100
+#define HUGESMTPTEXT     5000
+
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <sys/time.h>
+#include <arpa/inet.h>
+#include <netinet/in.h>
+#include <unistd.h>
+#include <alloca.h>
+#include <regex.h>
+#include <time.h>
+
 #include "sig.h"
 #include "readwrite.h"
 #include "stralloc.h"
@@ -22,136 +37,612 @@
 #include "rcpthosts.h"
 #include "timeoutread.h"
 #include "timeoutwrite.h"
+#include "timeoutconn.h"
 #include "commands.h"
+#include "dns.h"
+#include "wait.h"
+#include "fd.h"
+#include "out_log.h"
+#include "qmail-sasl.h"
+#include "qmail-p0f.h"
+#include "ucspitls.h"
+
+/* global /var/qmail/controls */
+int ctl_localiphost;
+int ctl_databytes;      /* default: 0 = no limit */
+int ctl_databytesP;     /* default: 5000  */
+int ctl_timeout;        /* timeout for connection to die */
+int ctl_maxrcpt;        /* max number of recipient we allow */
+int ctl_maxhops;        /* max number of hops we allow */
+int ctl_maxaddrlen;     /* max length a mailaddress can have */
+int ctl_maxcmdlen;      /* max length a smtp command may have */
+int ctl_tarpitcount;    /* when do we want to tarpit */
+int ctl_tarpitdelay;    /* tarpitdelay in seconds */
+int ctl_rcpttofixed;    /* if set, we have a fixed RCPT TO:<addr> */
+int ctl_reqbrackets;    /* enforce <> in the mail from & rcpt to / defaults to YES */
+char *ctl_p0fsock=0;    /* p0f socket, if 0 - no socket is there! */
+
+int tls_available = 0;
+int tls_started = 0;
+
+#define BMCHECK_BMF 1   /* badmailfrom */
+#define BMCHECK_BMT 2   /* badmailto */
+#define BMCHECK_BMH 3   /* badhelo */
+#define GMCHECK_GMF 4   /* goodmailfrom */
+int ctl_bmh, ctl_bmf, ctl_bmt, ctl_gmf;
+
+int ctl_clamd;          /* cheking for viruses via clamd / ip:port */
+int ctl_mfcheck;        /* enable/disable dns mx/a check */
+int ctl_orcheck;        /* enable/disable open relay checks */
+int ctl_rcptchecks;     /* enable/disable rcptchecks via external programs */
+int ctl_datechecks;     /* enable/disable usenet-YYYYMMDD checking */
+int ctl_bigbrother;     /* see TODO */
+int ctl_mxblacklist;    /* mxblacklist */
+stralloc ctl_outgoingip = {0}; /* outgoing ip */
+
+/* logging */
+int ctl_log_fd;         /* fd, where we want to log to */
+int ctl_log_in;         /* enable/disable incoming network traffik (S: ...) */
+int ctl_log_out;        /* enable/disable outgoing network traffik (C: ...) */
+int ctl_log_bmchecks;   /* enable/disable bad mail checks logging */
+int ctl_log_orchecks;   /* enable/disable open relay checks logging */
+int ctl_log_datechecks; /* enable/disable datechecks logging */
+int ctl_log_tarpitting; /* enable/disable tarpitting logging */
+
+/* esmtp auth */
+int ctl_auth_oldauth;   /* if >0, then the old ehlo resp. "AUTH=x1 x2" is also used */
+int ctl_auth_delay;     /* auth-delay is issued, when a password failure has occured */
+int ctl_auth_secure=(1|2|4|8|16); /* sasl methods in TLS mode */
+int ctl_auth_insecure=(4|8|16); /* sasl methods in NON-TLS mode */
+int *ctl_auth_current = &ctl_auth_insecure; /* depends on the current tls state */
+
+stralloc bmf = {0}; /* control/badmailfrom content */
+stralloc bmt = {0}; /* control/badmailto content */
+stralloc bmh = {0}; /* control/badhelo content */
+stralloc gmf = {0}; /* control/goodmailfrom content */
+stralloc dcf = {0}; /* control/datechecks content */
+stralloc bbr = {0}; /* control/bigbrother content */
+
+stralloc mxbl = {0};  /* mx blacklist */
+stralloc clamd = {0};
+unsigned int clamd_port;     /* daemon */
+unsigned int clamd_sport;    /* stream */
+unsigned int clamd_streamok = 0; /* stream state */
+struct ip_address clamd_ip;
+struct ip_address outip;
+
+/* misc variables */
+char *name="qmail-smtpd"; /* for commands.c */
+char smtpsize[FMT_ULONG+10];
+char **childargs;
+char *hostname;
+char *remoteip;
+char *remotehost;
+char *remoteinfo;
+char *local;
+char *relayclient;
+char *fakehelo;
+char *requireauth;
 
-#define MAXHOPS 100
-unsigned int databytes = 0;
+/* counting */
+int seenrcpt=0;      /* "rcpt to:" counting - tarpitting */
+int rcptcount=0;     /* how much rcpt to: we have allready */
+int seenmail=0;      /* "mail from:" counting - tarpitting */
+int authdone=0;      /* if 1, relay mail is okay */
+int auth_available=0;/* 1, if AUTH command can be used */
+int databytes=0;     /* current max size */
+int spamfeed=0;      /* are we getting spm via $BLCKLISTED */
+int timeoutconnect = 3*60;
 int timeout = 1200;
 
-int safewrite(fd,buf,len) int fd; char *buf; int len;
-{
-  int r;
-  r = timeoutwrite(timeout,fd,buf,len);
-  if (r <= 0) _exit(1);
-  return r;
-}
+stralloc addr     = {0};
+stralloc helohost = {0};
+stralloc greeting = {0};
+stralloc mailfrom = {0};
+stralloc rcptto   = {0};
+stralloc liphost  = {0};
+stralloc rcptchk  = {0};
+stralloc proto = {0};
+
+/* function prototypes */
+int addrallowed(void);
+int addrparse(char *arg);
+int bmcheck(int which, char *what); /* badmail* check */
+int mfcheck(void);    /* mail from check */
+int orcheck(void);    /* open relay check */
+int datecheck(void);  /* usenet-YYYYMMDD check */
+int rcptcheck(void);  /* rcpt to: check against external prog */
+int safewrite(int fd, char *buf, int len);
+int saferead(int fd, char *buf, int len);
+void dohelo(char *arg);
+void tarpit(char*,char*,char*);
+void acceptmessage(unsigned long qp);
+
+/* command functions */
+void smtp_rset(void);
+void smtp_quit(void);
+void smtp_noop(void);
+void smtp_vrfy(void);
+void smtp_data(void);
+void smtp_help(void);
+void smtp_rcpt(char *arg);
+void smtp_mail(char *arg);
+void smtp_helo(char *arg);
+void smtp_ehlo(char *arg);
+void smtp_auth(char *arg);
+void smtp_starttls(char *arg);
+
+extern void realrcptto_init();
+extern int realrcptto();
+
+#define DNS_VRFY -4
+
+/* our buffers */
+char clamdbuf[256];
+char clamsbuf[256];
+char ssinbuf[1024];
+char ssoutbuf[1024];
+char sserrbuf[1024];
+char smtpfrombuf[1024];
 
-char ssoutbuf[512];
+substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
 substdio ssout = SUBSTDIO_FDBUF(safewrite,1,ssoutbuf,sizeof ssoutbuf);
+substdio sserr = SUBSTDIO_FDBUF(safewrite,-1,sserrbuf,sizeof sserrbuf);
+substdio smtpfrom = SUBSTDIO_FDBUF(saferead,-1,smtpfrombuf,sizeof smtpfrombuf);
+substdio clamdsock = SUBSTDIO_FDBUF(saferead, -1, clamdbuf, sizeof clamdbuf);
+substdio clamssock = SUBSTDIO_FDBUF(saferead, -1, clamsbuf, sizeof clamsbuf);
+
+void die() { flush(); _exit(1); }
+void out_die(char *s) { out_err(s); die(); }
+void dogreet(char *s) { doserv(); out(s); out(greeting.s); doeol(); }
+
+/* rfc2554
+ * 530 Authentication required
+ * 534 Authentication mechanism is too weak
+ * 538 Encryption required for requested authentication mechanism
+ * 454 Temporary authentication failure
+ *
+ * rfc3207
+ * 220 Ready to start TLS
+ * 501 Syntax error (no parameters allowed)
+ * 454 TLS not available due to temporary reason
+ *
+ * rfc1893 + rfc2034 + rfc3463
+ * where:  codes must appear in all 2xx, 4xx, and 5xx lines
+ * except: initial greeting and any response to HELO or EHLO
+ * note:   3xx responses are NOT included in this list
+ */
+void (*die_alarm)(void);
+void die_alarm1()   { out_die("451 4.4.2 timeout"); }
+void die_alarm2()   { Log("die_alarm2()"); flush(); }
+
+void die_read()     { doname(); Log("ERROR: eof from client - SPAMMER?\n"); die(); }
+void die_nomem()    { out_die("421 4.3.0 out of memory"); }
+void die_control()  { out_die("421 4.3.0 unable to read controls"); }
+void die_ipme()     { out_die("421 4.3.0 unable to figure out my IP addresses");  }
+void die_newline()  { out_die("451 4.3.0 see http://pobox.com/~djb/docs/smtplf.html."); }
+void die_smf()      { out_die("451 4.3.0 dns temporary failure"); }
+void die_callback() { out_die("451 4.3.0 sender address verification failed"); }
+void die_nosocket() { out_die("454 4.3.0 too much load / unable to create socket"); }
+void die_qqt()      { out_die("451 4.3.0 qqt failure"); }
+void die_child()    { out_die("454 4.3.0 can't do auth (problem with child)"); }
+void die_fork()     { out_die("454 4.3.0 unable to fork()"); }
+void die_pipe()     { out_die("454 4.3.0 can't do auth (unable to open pipe)"); }
+void die_write()    { out_die("454 4.3.0 can't do auth (unable to write pipe)"); }
+void die_cdb()      { out_die("421 4.3.0 unable to read cdb user database"); }
+void die_sys()      { out_die("421 4.3.0 unable to read system user database"); }
+void die_syserr()   { out_die("421 4.3.0 system error"); }
+
+void die_with1()    { out_die("553 5.1.1 sorry, no mailbox here by that name."); }
+void die_with2()    { out_die("421 4.3.0 unable to verify recipient/sender (misuse)"); }
+void die_with3()    { out_die("421 4.3.0 unable to verify recipient/sender (internal)"); }
+void die_with11()   { out_die("451 4.1.1 bad destination mailbox address"); }
+void die_with12()   { out_die("451 4.1.2 bad destination system address"); }
+void die_with13()   { out_die("451 4.1.3 bad destination mailbox address syntax"); }
+void die_with14()   { out_die("451 4.1.4 destination mailbox address ambiguous"); }
+void die_with16()   { out_die("451 4.1.6 mailbox has moved"); }
+void die_with17()   { out_die("451 4.1.7 bad sender's mailbox address syntax"); }
+void die_with18()   { out_die("451 4.1.8 bad sender's system address"); }
+void die_with21()   { out_die("452 4.2.1 mailbox disabled, not accepting messages"); }
+void die_with22()   { out_die("452 4.2.2 mailbox full"); }
+void die_with111()  { out_die("421 4.3.0 unable to verify recipient/sender (temporary)"); }
+void die_with112()  { out_die("421 4.3.0 unable to verify recipient/sender (greylisting)"); }
+
+/* this is stolen from postfix :) */
+void die_wantrcpt() { out_die("221 2.0.0 error: I can break rules, too. goodbye!"); }
+
+void err_unrecog()  { out_err("500 5.5.2 unrecognised command"); }
+void err_authabrt() { out_err("501 5.0.0 auth exchange cancelled"); }
+void err_authdone() { out_err("503 5.5.0 you're already authenticated"); }
+void err_authmail() { out_err("503 5.5.0 no auth during mail transaction"); }
+void err_unimpl()   { out_err("502 5.5.1 unimplemented"); }
+void err_wantmail() { out_err("503 5.5.1 MAIL first"); }
+int  err_noauth()   { out_err("504 5.5.1 auth type unimplemented"); return -1; }
+int  err_authin()   { out_err("501 5.5.1 malformed auth input"); return -1; }
+void err_authreq()  { out_err("503 5.5.1 you must authenticate first"); }
+void err_authnot()  { out_err("503 5.3.3 auth not available"); }
+void err_synsize()  { out_err("501 5.0.0 bad message size syntax"); }
+void err_size()     { out_err("552 5.3.4 sorry, that message size exceeds my limit"); }
+void err_tmh()      { out_err("554 5.4.6 too many hops, this message is looping"); }
+void err_syntax()   { out_err("501 5.5.4 syntax error"); }
+void err_helo()     { out_err("501 5.5.4 syntax error, I need your hostname"); }
+void err_npa()      { out_err("501 5.5.4 syntax error, no parameters allowed"); }
+void err_badaddr()  { out_err("501 5.5.4 syntax error, bad mail address"); }
+void err_authfail() { out_err("535 5.7.0 authorization failed"); }
+void err_authweak() { out_err("534 5.7.0 authentication mechanism is too weak"); }
+void err_badrcpt()  { out_err("553 5.1.1 sorry, no mailbox here by that name."); }
+
+/* we die after tarpitting! */
+void die_bmf()  { tarpit("553", "5.7.1", "sorry, your envelope sender has been denied"); }
+void die_bmt()  { tarpit("553", "5.7.1", "sorry, your envelope recipient has been denied"); }
+void die_bmh()  { tarpit("553", "5.7.1", "sorry, your helo or ehlo is incorrect"); }
+void die_hmf()  { tarpit("553", "5.7.1", "sorry, your envelope sender domain must exist"); }
+void die_tmr()  { tarpit("553", "5.5.3", "sorry, to many recipients"); }
+void die_rbuf() { tarpit("553", "5.5.3", "sorry, my recipients buffer is to small for you"); }
+void die_nogw() { tarpit("553", "5.7.1", "sorry, that domain isn't in my list of allowed rcpthosts"); }
+void die_lcmd() { tarpit("553", "5.5.2", "sorry, the given command is t00 long!"); }
+void die_date() { tarpit("553", "5.7.1", "sorry, this mailaddy is not valid anymore!"); }
+
+/* tarpit 2 logs some extra info + tarpits */
+void tarpit2(char *code, char *ext, char *msg, char *type, stralloc *smtp) {
+  int l=0,i=0;
 
-void flush() { substdio_flush(&ssout); }
-void out(s) char *s; { substdio_puts(&ssout,s); }
+  if (!stralloc_0(smtp)) die_nomem();
+  for (;;) {
+    l=str_chr(smtp->s+i, '\n');
+    if (!smtp->s[i]) break;
+    doname(); Log(type); Logn(smtp->s+i, l); Log("\n");
+    i+=l+1;
+  }
+  tarpit(code, ext, msg);
+}
 
-void die_read() { _exit(1); }
-void die_alarm() { out("451 timeout (#4.4.2)\r\n"); flush(); _exit(1); }
-void die_nomem() { out("421 out of memory (#4.3.0)\r\n"); flush(); _exit(1); }
-void die_control() { out("421 unable to read controls (#4.3.0)\r\n"); flush(); _exit(1); }
-void die_ipme() { out("421 unable to figure out my IP addresses (#4.3.0)\r\n"); flush(); _exit(1); }
-void straynewline() { out("451 See http://pobox.com/~djb/docs/smtplf.html.\r\n"); flush(); _exit(1); }
-
-void err_bmf() { out("553 sorry, your envelope sender is in my badmailfrom list (#5.7.1)\r\n"); }
-void err_nogateway() { out("553 sorry, that domain isn't in my list of allowed rcpthosts (#5.7.1)\r\n"); }
-void err_unimpl() { out("502 unimplemented (#5.5.1)\r\n"); }
-void err_syntax() { out("555 syntax error (#5.5.4)\r\n"); }
-void err_wantmail() { out("503 MAIL first (#5.5.1)\r\n"); }
-void err_wantrcpt() { out("503 RCPT first (#5.5.1)\r\n"); }
-void err_noop() { out("250 ok\r\n"); }
-void err_vrfy() { out("252 send some mail, i'll try my best\r\n"); }
-void err_qqt() { out("451 qqt failure (#4.3.0)\r\n"); }
+void tarpit(char *code, char *ext, char *msg) {
+  int i=ctl_tarpitdelay;
 
+  if (ctl_log_tarpitting) {
+    doname(); Log("TARPIT: ");
+    if (mailfrom.len){ Log("<"); Logn(mailfrom.s, mailfrom.len-1); Log("> to "); }
+    if (addr.len)    { Log("<"); Logn(addr.s, addr.len-1); Log(">"); }
+    if (helohost.s)  { Log(" | helo(");         Log(helohost.s);  Log(")"); }
+    if (remoteinfo)  { Log(" | remoteinfo(");   Log(remoteinfo);  Log(")"); }
+    Log("\n");
+  }
 
-stralloc greeting = {0};
+  doserv();
+  out(code);Out("-");Log(" ");out(ext);out(" ");
+  out(msg);doeol();
+
+  sleep(i*1+1);
+  Out(code);Out("-");Out(ext);Out(" ");
+  Out("hm let me see ...\r\n");
+  if (flush() == -1) die();
+
+  sleep(i*2+1);
+  Out(code);Out("-");Out(ext);Out(" ");
+  Out("hm does it look good ?\r\n");
+  if (flush() == -1) die();
+
+  sleep(i*3+1);
+  Out(code);Out("-");Out(ext);Out(" ");
+  Out("No! You are a bad guy!\r\n");
+  if (flush() == -1) die();
+
+  sleep(i*4+1);
+  Out(code);Out(" ");Out(ext);Out(" ");
+  Out(msg);Out("\r\n");
+  die(); /* die() flushes */
+}
 
-void smtp_greet(code) char *code;
+void smtp_help(void)
 {
-  substdio_puts(&ssout,code);
-  substdio_put(&ssout,greeting.s,greeting.len);
+  out_err("214 2.0.0 qmail patched (version: " VERSION ")!");
 }
-void smtp_help()
+
+void smtp_noop(void)
 {
-  out("214 qmail home page: http://pobox.com/~djb/qmail.html\r\n");
+  out_err("250 2.0.0 noop okay");
 }
-void smtp_quit()
+
+void smtp_vrfy(void)
 {
-  smtp_greet("221 "); out("\r\n"); flush(); _exit(0);
+  out_err("252 2.0.0 send some mail, I'll try my best");
 }
 
-char *remoteip;
-char *remotehost;
-char *remoteinfo;
-char *local;
-char *relayclient;
+void smtp_quit(void)
+{
+  out_err("221 2.0.0 good bye!");
+  _exit(0);
+}
 
-stralloc helohost = {0};
-char *fakehelo; /* pointer into helohost, or 0 */
+void smtp_helo(char *arg)
+{
+  if (!*arg) { err_helo(); return; }
+  dohelo(arg);
 
-void dohelo(arg) char *arg; {
-  if (!stralloc_copys(&helohost,arg)) die_nomem(); 
-  if (!stralloc_0(&helohost)) die_nomem(); 
-  fakehelo = case_diffs(remotehost,helohost.s) ? helohost.s : 0;
+  if (ctl_bmh) if (bmcheck(BMCHECK_BMH, helohost.s)) die_bmh();
+
+  rcptcount = 0; seenmail = 0;
+  dogreet("250 ");
 }
 
-int liphostok = 0;
-stralloc liphost = {0};
-int bmfok = 0;
-stralloc bmf = {0};
-struct constmap mapbmf;
+void dosasl() {
+  int i=0,space=0;
+  while (i<SASL_MAX) {
+    if ((*ctl_auth_current & 1<<i) == 1<<i) {
+      if (space) out(" ");
+      out(sasl[i]); space=1;
+    }
+    i++;
+  }
+}
 
-void setup()
+void smtp_ehlo(char *arg)
+{
+  if (!*arg) { err_helo(); return; }
+  dohelo(arg);
+
+  if (ctl_bmh) if (bmcheck(BMCHECK_BMH, helohost.s)) die_bmh();
+
+  rcptcount = 0; seenmail = 0;
+  dogreet("250-");
+  if (auth_available) {
+    if (ctl_auth_oldauth) {
+      doserv(); out("250-AUTH=LOGIN"); doeol(); /* for old progs */
+    }
+    doserv(); out("250-AUTH "); dosasl(); doeol(); /* rfc */
+  }
+  out_err("250-ENHANCEDSTATUSCODES");
+  out_err("250-PIPELINING");
+  if (tls_available && !tls_started) out_err("250-STARTTLS");
+  if (ctl_databytes) out_err(smtpsize);
+
+  /* some people claim that this isn't correct ... who cares :) */
+  out_err("250 8BITMIME");
+  flush();
+}
+
+void smtp_rset()
+{
+  seenmail = 0;
+  seenrcpt = 0;
+  out_err("250 2.0.0 flushed");
+}
+
+/* scan for AUTH= or SIZE= oder BODY= ... in MAIL FROM:... line */
+char *argparse(char *arg, char *what) {
+  char *x=arg;
+  int len=strlen(arg),i;
+  int wl=strlen(what);
+
+  for (i=0; len>i+wl; i+=str_chr(x, ' ')+1) {
+    x+=i;
+    while (*x == ' ') x++; /* skip spaces */
+    if (case_diffb(x, wl, what) == 0) return x+wl;
+  }
+
+  return 0;
+}
+
+void smtp_mail(char *arg)
 {
   char *x;
-  unsigned long u;
- 
-  if (control_init() == -1) die_control();
-  if (control_rldef(&greeting,"control/smtpgreeting",1,(char *) 0) != 1)
-    die_control();
-  liphostok = control_rldef(&liphost,"control/localiphost",1,(char *) 0);
-  if (liphostok == -1) die_control();
-  if (control_readint(&timeout,"control/timeoutsmtpd") == -1) die_control();
-  if (timeout <= 0) timeout = 1;
 
-  if (rcpthosts_init() == -1) die_control();
+  if (!addrparse(arg)) { err_badaddr(); return; }
 
-  bmfok = control_readfile(&bmf,"control/badmailfrom",0);
-  if (bmfok == -1) die_control();
-  if (bmfok)
-    if (!constmap_init(&mapbmf,bmf.s,bmf.len,0)) die_nomem();
- 
-  if (control_readint(&databytes,"control/databytes") == -1) die_control();
-  x = env_get("DATABYTES");
-  if (x) { scan_ulong(x,&u); databytes = u; }
-  if (!(databytes + 1)) --databytes;
- 
-  remoteip = env_get("TCPREMOTEIP");
-  if (!remoteip) remoteip = "unknown";
-  local = env_get("TCPLOCALHOST");
-  if (!local) local = env_get("TCPLOCALIP");
-  if (!local) local = "unknown";
-  remotehost = env_get("TCPREMOTEHOST");
-  if (!remotehost) remotehost = "unknown";
-  remoteinfo = env_get("TCPREMOTEINFO");
-  relayclient = env_get("RELAYCLIENT");
-  dohelo(remotehost);
+  if (spamfeed) {
+    if (!seenmail) {
+      if (!stralloc_copys(&mailfrom,addr.s)) die_nomem();
+      if (!stralloc_0(&mailfrom)) die_nomem();
+    }
+    out_err("250 2.1.0 welcome spammer :)");
+    seenmail = 1; return;
+  }
+
+  /* This is the real databytes initialisation.
+   * If spamfeed is set, the maximum is defined by databytes+ :)
+   */
+  databytes=ctl_databytes;
+  if (ctl_databytes) {
+    if ((x=argparse(arg, "SIZE="))) {
+      if (scan_ulong(x, &databytes) == 0) { err_synsize(); return; }
+      if (databytes > ctl_databytes) { err_size(); return; }
+    }
+  }
+
+  if (ctl_gmf) {
+    if (bmcheck(GMCHECK_GMF, addr.s)) {
+      out_err("250 2.1.0 ok!");
+      if (!stralloc_copys(&rcptto,"")) die_nomem();
+      if (!stralloc_copys(&mailfrom,addr.s)) die_nomem();
+      if (!stralloc_0(&mailfrom)) die_nomem();
+      seenmail = 1; return;
+    }
+  }
+  if (ctl_bmf) { if (bmcheck(BMCHECK_BMF, addr.s)) die_bmf(); }
+
+  switch (mfcheck()) {
+    case DNS_HARD: die_hmf();
+    case DNS_SOFT: die_smf();
+    case DNS_MEM:  die_nomem();
+    case DNS_VRFY: die_callback();
+  }
+
+  if (requireauth && !authdone) { err_authreq(); return; }
+
+  if (!stralloc_copys(&rcptto,"")) die_nomem();
+  if (!stralloc_copys(&mailfrom,addr.s)) die_nomem();
+  if (!stralloc_0(&mailfrom)) die_nomem();
+  out_err("250 2.1.0 ok");
+  seenmail = 1;
+}
+
+void smtp_rcpt(char *arg)
+{
+  static int init_done=0;
+
+  if (!seenmail) {
+    err_wantmail();
+    return;
+  }
+
+  if (spamfeed) {
+    out_err("250 2.1.5 I feed spamassassin now!");
+    seenrcpt = 1;
+    return;
+  }
+
+  if (ctl_rcpttofixed) {
+    out_err("250 2.1.5 ok!"); /* ok! */
+    seenrcpt = 1;
+    return;
+  }
+
+  if (!init_done) {
+    realrcptto_init();
+    init_done=1;
+  }
+
+  if (!addrparse(arg)) { err_badaddr(); return; }
+  if (ctl_bmt) { if (bmcheck(BMCHECK_BMT, addr.s)) die_bmt(); }
+
+  if (relayclient) {
+    --addr.len; /* remove '\0' */
+    if (!stralloc_cats(&addr,relayclient)) die_nomem();
+    if (!stralloc_0(&addr)) die_nomem();
+  } else {
+    if (!addrallowed()) { die_nogw(); return; }
+  }
+
+  if (!realrcptto(addr.s)) {
+    err_badrcpt(); return;
+  }
+
+  if (authdone) {
+    /* if the user is a 'user@host.domain', than only relaying with a
+     * MAIL FROM:<user@host.domain> is allowed!
+     */
+     if (str_chr(remoteinfo, '@') != strlen(remoteinfo)) {
+       if (!str_equal(mailfrom.s, remoteinfo)) {
+         die_bmf(); /* this function does a tarpit! */
+       }
+     }
+  }
+
+  if (ctl_maxrcpt)
+    if (rcptcount > ctl_maxrcpt)
+      if (!authdone) die_tmr();
+
+  if (ctl_tarpitcount)
+    if (rcptcount > ctl_tarpitcount)
+      if (!authdone) while (sleep(ctl_tarpitdelay));
+
+  datecheck();
+
+  if (!authdone)
+    if (rcptcheck() != 0) { err_badrcpt(); return; }
+
+  if (!stralloc_cats(&rcptto,"T")) die_nomem();
+  if (!stralloc_cats(&rcptto,addr.s)) die_nomem();
+  if (!stralloc_0(&rcptto)) die_nomem();
+
+  seenrcpt = 1;
+  rcptcount += 1;
+  out_err("250 2.1.5 ok");
 }
 
+void smtp_auth(char *arg)
+{
+  char *cmd=arg;
+  int i;
+
+  if (!auth_available) { err_unimpl(); return; }
+  if (authdone) { err_authdone(); return; }
+  if (seenmail) { err_authmail(); return; }
+
+  if (!stralloc_copys(&user,"")) die_nomem();
+  if (!stralloc_copys(&pass,"")) die_nomem();
+  if (!stralloc_copys(&resp,"")) die_nomem();
+
+  i = str_chr(cmd,' ');
+  arg = cmd + i;
+  while (*arg == ' ') ++arg;
+  cmd[i] = 0;
+  for (i = 0; authcmds[i].text; ++i)
+    if (case_equals(authcmds[i].text,cmd))
+      break;
+  auth_for=MODE_SMTPD;
+  switch (authcmds[i].fun(arg)) {
+    case 0:
+      authdone = 1;
+      relayclient = "";
+      remoteinfo = user.s;
+      if (!env_unset("TCPREMOTEINFO")) die_read();
+      if (!env_put2("TCPREMOTEINFO", remoteinfo)) die_nomem();
+      /* for user, which have authenticated, $BLACKLISTED will not work! */
+      spamfeed=0;
+      break;
+    case ERR_AUTH_FAILED: err_authfail(); break;
+    case ERR_AUTH_INPUT:  err_authin();   break;
+    case ERR_AUTH_ABORT:  err_authabrt(); break;
+  }
+}
+
+void smtp_starttls(arg) char *arg; {
+
+  if (!tls_available || tls_started)
+    return err_unimpl(arg);
+  out_err("220 2.0.0 Ready to start TLS");
 
-stralloc addr = {0}; /* will be 0-terminated, if addrparse returns 1 */
+  if (!ucspitls())
+    die_syserr();
 
-int addrparse(arg)
-char *arg;
+  tls_started = 1;
+  /* reset SMTP state */
+  seenmail = 0;
+}
+
+void dohelo(char *arg)
+{
+  if (!stralloc_copys(&helohost,arg)) die_nomem();
+  if (!stralloc_0(&helohost)) die_nomem();
+  fakehelo = case_diffs(remotehost,helohost.s) ? helohost.s : 0;
+}
+
+int safewrite(int fd, char *buf, int len)
+{
+  int r;
+  r = timeoutwrite(ctl_timeout,fd,buf,len);
+  if (r <= 0) die();
+  return r;
+}
+
+int saferead(int fd, char *buf, int len)
+{
+  int r;
+  flush();
+  r = timeoutread(ctl_timeout,fd,buf,len);
+  if (r == -1) if (errno == error_timeout) die_alarm();
+  if (r <= 0) die_read();
+  return r;
+}
+
+int addrparse(char *arg)
 {
   int i;
   char ch;
   char terminator;
   struct ip_address ip;
-  int flagesc;
-  int flagquoted;
- 
+  int flagesc=0;
+  int flagquoted=0;
+
   terminator = '>';
   i = str_chr(arg,'<');
-  if (arg[i])
+  if (arg[i]) {
     arg += i + 1;
-  else { /* partner should go read rfc 821 */
+  } else {
+    if (ctl_reqbrackets) return 0; /* partner should go read rfc 821 */
+    /* old style, without <> */
     terminator = ' ';
     arg += str_chr(arg,':');
     if (*arg == ':') ++arg;
@@ -162,9 +653,7 @@
   if (*arg == '@') while (*arg) if (*arg++ == ':') break;
 
   if (!stralloc_copys(&addr,"")) die_nomem();
-  flagesc = 0;
-  flagquoted = 0;
-  for (i = 0;ch = arg[i];++i) { /* copy arg to addr, stripping quotes */
+  for (i = 0; (ch = arg[i]); ++i) { /* copy arg to addr, stripping quotes */
     if (flagesc) {
       if (!stralloc_append(&addr,&ch)) die_nomem();
       flagesc = 0;
@@ -178,10 +667,11 @@
       }
     }
   }
+
   /* could check for termination failure here, but why bother? */
   if (!stralloc_append(&addr,"")) die_nomem();
 
-  if (liphostok) {
+  if (ctl_localiphost) {
     i = byte_rchr(addr.s,addr.len,'@');
     if (i < addr.len) /* if not, partner should go read rfc 821 */
       if (addr.s[i + 1] == '[')
